



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Thinking in Unity3D：材质系统概览</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Thinking in Unity3D：材质系统概览</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 15:36:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/246968/201603/246968-20160325231452167-1466000311.png" /></p>
<h3>关于《<a href="http://www.cnblogs.com/geniusalex/p/5321545.html" rel="external nofollow noreferrer">Thinking in Unity3D</a>》</h3>
<p>笔者在研究和使用Unity3D的过程中，获得了一些Unity3D方面的信息，同时也感叹Unity3D设计之精妙。不得不说，笔者最近几年的引擎研发工作中，早已习惯性的从Unity3D中寻找解决方案。</p>
<div>Unity3D虽比不上UE那么老练沉稳，气势磅礴。也比不上CE那样炫丽多姿，盛气凌人。但它的发展势如破竹，早已遍地生花！故而在此记录一些自己的心得体会，供大家参详交流。若有欠妥之处，还望各位及时指正。</div>
<div>&nbsp;</div>
<div><a href="http://www.cnblogs.com/geniusalex/p/5321545.html" rel="external nofollow noreferrer">Thinking in Unity3D</a>由一系列文章组成，文章列表地址：<a href="http://www.cnblogs.com/geniusalex/p/5321545.html" rel="external nofollow noreferrer">http://www.cnblogs.com/geniusalex/p/5321545.html</a></div>
<div>&nbsp;</div>
<h3>什么是材质？</h3>
<hr />
<p>材质是一个相对广泛的概念，不同的专业领域有不同的定义。 在此也不一一举例说明了，我们只说在3D游戏引擎中，材质的定义。</p>
<p>材质的本质定义，是指能够描述一个物体的显示外观的一系列数据。它包括几个方面</p>
<p>1、渲染状态</p>
<p>渲染状态是指早期的setRenderState那一套东西。比如，前后面裁剪，是否开启混合，混合因子等等。</p>
<p>2、着色方式</p>
<p>着色方式，在固定管线年代，是通过一系列的API进设置。 在可编程管线年代。就对应的是我们的着色器代码。</p>
<p>3、参数</p>
<p>不管是固定管线还是非固定管线，我们都可以设置一些参数用于着色计算。比如颜色，光源信息等等</p>
<p>4、纹理贴图</p>
<p>纹理贴图是表现一个物体表现的颜色细节的必不可少的东西。就是一张张图片。</p>
<p>有了上面的这些数据后，我们就可以根据一定的运算规则，将一个几何体的质感显示为我们想要的样子。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/246968/201603/246968-20160326132830792-280250709.png" /></p>
<p>材质、Shader、模型关系图</p>
<h3>材质系统的常见需求</h3>
<hr />
<p>一个工具或者系统的设计不可能是凭空而出的。 一定是根据需求和经验的积累，才形成了我们今天这种&ldquo;材质系统&rdquo;的概念。 说到这里，那么我们常见的材质系统需要做到什么样子呢。</p>
<p>一、模板 + 实例</p>
<p>材质是一个模板，通过对某一个材质进行实例化，指定不同的数据和贴图，就可以让物体表现出不同的显示效果。 和Class + Object的关系很像。</p>
<p>二、多Pass</p>
<p>有时候，我们为了实现一个绘制效果，靠单次绘制是无法实现的。比如描边效果。 这就要求我们单个物体能够在进行绘制的时候，多次提交材质并绘制。</p>
<p>三、多Technique</p>
<p>多Technique是指一个材质中，应该包含不只一个实现方案。 这样当我们进行材质更替，或者进行高中低端机适配的时候。 就不会那么麻烦。 同时在数据管理上，也显得更为规范。</p>
<p>四、高中低端机适配</p>
<p>高中低端机适配是一个很重要的特性，因为玩家的机型不可能是一样的。 在需要保证效率的情况下，我们很多时候需要降低物体渲染的复杂度。在<a href="http://www.cnblogs.com/geniusalex/p/5277837.html" rel="external nofollow noreferrer">《3D游戏中的画质与效率适配》</a>一文中。笔者也描述过，有两种方案。 一种是通过宏定义，一种是动态切换Technique。</p>
<p>总结下来，就是说一个材质模板文件应该像这样的一个结构</p>
<div>
<pre class="prettyprint linenums">MaterialTemplate<br />
{<br />
     Technique<br />
     {<br />
          Pass{}<br />
          Pass{}<br />
     }<br />
     Technique<br />
     {<br />
          Pass{}<br />
          Pass{}<br />
     }<br />
}</pre>
</div>
<h3>Unity3D中的材质系统</h3>
<hr />
<p>在说到Unity3D中的材质系统的时候，我们先来看一下我们创建一个材质需要做的事情。</p>
<p>一、创建一个Shader并编写出自己想要的效果</p>
<p>二、创建一个Material并将这个Material的Shader指定为自己的材质</p>
<p>三、为这个Material设置参数，赋上贴图等</p>
<p>四、将创建好的Material拖到对象上</p>
<p>我们再来看一个典型的Shader应该具备的内容</p>
<div>
<pre class="prettyprint linenums">Shader "MyShader" {<br />
    Properties {<br />
        _MyTexture ("My Texture", 2D) = "white" { }<br />
        // other properties like colors or vectors go here as well<br />
    }<br />
    SubShader {

          LOD<br />
        // here goes the 'meat' of your<br />
        // - surface shader or<br />
        // - vertex and program shader or<br />
        // - fixed function shader

          Pass{}

          Pass{}

    }<br />
    SubShader {

          LOD<br />
        // here goes a simpler version of the SubShader<br />
        // above than can run on older graphics cards

          Pass{}

          Pass{}<br />
    }<br />
}</pre>
</div>
<p>我们可以看到。 每一个Shader有多个SubShader，每一个SubShader有多个Pass。 这样看起来和我们前面提到的MaterialTemplate结构几乎一致。</p>
<p>而在Unity3D中。Shader就是材质模版。 Material就是一个材质实例。 每一个Material你可以认为是一个材质实例的序列化存储。</p>
<h3>Unity3D中的材质LOD</h3>
<hr />
<p>那对于前面提到的 高中低端机适配。 有两种方法解决。一是通过宏定义，这个并不是Unity3D的推荐方式，且需要Shader编写的相关知识，在这里不作详细讨论。 如果有兴趣的朋友，可以访问括号中的链接（<a href="http://docs.unity3d.com/Manual/SL-MultipleProgramVariants.html" rel="external nofollow noreferrer">http://docs.unity3d.com/Manual/SL-MultipleProgramVariants.html</a>），以后的文章在涉及Unity3D的Shader编写方面的内容时，再进行讨论。 在此主要讨论Unity3D中通过材质LOD进行画质控制。</p>
<p>在Unity3D的Shader中，可以为每一个SubShader指定一个LOD值，这个LOD值可以通过设置<strong>Shader.globalMaximumLOD</strong>和<strong>Shader.maximumLOD</strong>来实现SubShader的切换。所有的SubShader按顺序进行判定，当一个SubShader满足下面两个条件时，才表明可用。</p>
<p>1、SubShaderLOD值小于设定的值。（你可以把LOD看作是开销，开销越大的SubShader指定越高的LOD值）</p>
<p>2、SubShader所有Pass使用到的显卡特性被当前设备支持。</p>
<p><strong>注</strong>：Shader API文档地址：<a href="http://docs.unity3d.com/ScriptReference/Shader.html" rel="external nofollow noreferrer">http://docs.unity3d.com/ScriptReference/Shader.html</a></p>
<p><strong>注</strong>：Shader LOD文档地址：<a href="http://docs.unity3d.com/Manual/SL-ShaderLOD.html" rel="external nofollow noreferrer">http://docs.unity3d.com/Manual/SL-ShaderLOD.html</a></p>
<p><strong>注</strong>：Unity3D为每一档的内置Shader都设置了一个默认值，在LOD文档中有</p>
<p><strong>注</strong>：如果不指定LOD值，那LOD=infinite 。 你可以当它是一个小于0的值。</p>
<p><strong>注</strong>：这个值除了可以自己给以外，还可以在Edit-&gt;Project Settings-&gt;Quality面板中指定，如下图</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/246968/201603/246968-20160325231454511-707610605.png" /></p>
<p>设置面板</p>
<h3>Unity3D中的材质替换</h3>
<hr />
<p><strong>官方文档地址</strong>：<a href="http://docs.unity3d.com/Manual/SL-ShaderReplacement.html" rel="external nofollow noreferrer">http://docs.unity3d.com/Manual/SL-ShaderReplacement.html</a></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/246968/201603/246968-20160325231456511-2007589462.png" /></p>
<p>夜视效果</p>
<p>有时候，我们希望能够进行一些特殊操作。将场景物体的按另一种渲染方式渲染到RT中。 比如，仅渲染物体的深度，把物体渲染成纯白，把物体渲染成红绿热成像模式等等。但是，我们的材质在一开始就指定好了。如果要替换的话，就需要遍历所有对像，为它们重新指定材质。渲染完毕后，再切换回来。Unity3D为我们提供了更直接的方式。<strong>Camera.RenderWithShader</strong>和<strong>Camera.SetReplacementShader。</strong>前者是仅作用一次，后者是一直生效，如果想取消设置。 使用<strong>Camera.ResetReplacementShader</strong>即可<strong>。</strong></p>
<p><strong> <br /></strong></p>
<p>那么问题来了，我们有时候只想渲染一些特殊的物体。比如，我们想处理除主角以外的内容。 这就需要对主角进行剔除。 那上面两个函数的第二个参数<strong>replacementTag</strong>就起作用了。如果设置了它，在进行材质替换时，它会和SubShader中的 RenderType的值 进行比对。 比如，我们即将替换的材质如下。</p>
<div>
<pre class="prettyprint linenums">Shader "EffectShader" {<br />
     SubShader {<br />
         Tags { "RenderType"="Opaque" }<br />
         Pass {<br />
             ...<br />
         }<br />
     }<br />
     SubShader {<br />
         Tags { "RenderType"="SomethingElse" }<br />
         Pass {<br />
             ...<br />
         }<br />
     }<br />
...

}</pre>
</div>
<p>如果我们调用了camera.SetReplacementShader (EffectShader, "RenderType");那么，一个物体在被渲染时，会产生以下几种结果。</p>
<p>1、如果物体当前激活的SubShader的RenderType是Opaque，那么将会采用EffectShader的第一个SubShader。</p>
<p>2、如果物体当前激活的SubShader的RenderType是SomethingElse，那么将会采用EffectShader的第二个SubShader。</p>
<p>3、如果物体当前激活的SubShader的RenderType在EffectShader中没有与之对应的项，此物体将会在渲染中被忽略。</p>
<p>4、如果物体当前激活的SubShader没有RenderType这个Tag,此物体将会在渲染中被忽略。</p>
<h3>结束语</h3>
<hr />
<p>Unity3D拥有着一个灵活的渲染管线和自由的材质系统。与其它图形引擎不一样的是，Unity3D针对游戏需求所留出来的接口非常好用。</p>
<p>而本文仅仅是对Unity3D的材质系统进行初步的描述。要想完全把Unity3D的材质系统总结出来，不是一两篇文章可以搞定的。Unity3D文档中的 Shader Reference可以作为一个十分不错的开始<a href="http://docs.unity3d.com/Manual/SL-Reference.html" rel="external nofollow noreferrer">http://docs.unity3d.com/Manual/SL-Reference.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96ykdn8.html">LoadRunner 11 安装及破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ogxrlq.html">virtualBox 打开旧的ubuntu虚拟机镜像时找不到网卡的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq41mejq.html">四个查找命令find&comma;locate&comma;whereis&comma;which的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnm030q.html">gd-jpeg&colon; JPEG library reports unrecoverable error 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mmpxgq.html">HDU 4046 Panda</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wz02lq.html">【递归】Vijos P1114 FBI树（NOIP2004普及组第三题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzvvlq.html">Coding Your Life</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj05px8.html">RxJava整合Retrofit遇到的问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7oj38.html">Win10 - MySQL 5&period;7 密码重置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjop469.html">&lbrack;总结&rsqb;高效的jQuery代码编写技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1gx21q.html">js中文输入法字符串截断</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gd1keq.html">MySQL中MyISAM与InnoDB区别及选择&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvg2g28.html">kaptcha验证码插件使用与参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w337gq.html">Spring中的&commat;Bean注解、&commat;Configuration注解、&commat;Value</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o0owx8.html">438&period; Find All Anagrams in a String</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rn1439.html">Bootstrap 时间控件datetimepicker与timepicker</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j20lnq.html">前端工程化之webpack中配置babel-loader（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw36x79.html">hdu 1217 汇率 Floyd</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwo36y8.html">20165305 苏振龙《Java程序设计》第九周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2mmoj9.html">ARM的栈指令&lpar;转&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o5qy12qr.html">使用TSQL查询和更新 JSON 数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/g495z69z.html">CORS详解&lbrack;译&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/495xrz8z.html">&period;NET Core全新路线图</a>
			</li>
						<li><a href="https://www.batexi.com/a/390vdn8d.html">查看w3wp进程占用的内存及&period;NET内存泄露&comma;死锁分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93yxw83.html">JavaScript Math和Number对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gj3497.html">&period;net erp（办公oa）开发平台架构概要说明之表单设计器</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rng7q0.html">【Python五篇慢慢弹】快速上手学python</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e0yjq1.html">解决VS2008在win7找不到输入序列号的地方</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwolk97.html">C&num;项目中文件的具体含义</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zvkv9y.html">C&num;&mdash;&mdash;传值参数&lpar;1&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
